% FFT eines Eigangssignals
% Mathias Lindner
% Juli 2015

%clear;
clc;
close all;



f = 1/dt;					% Frequenz
fn = f/2;					% "Nyquist"-Frequenz
df = f / length(signal);	% Frequenzauflösung

% FFT
fft_cplx = fft(signal);

% begrenzen auf 1/50 der Samplerate, um Subsampling zu verhindern
fft_length = round(length(signal) / 50);
fft_cplx_ltd = fft_cplx;
fft_cplx_ltd((fft_length+1):(end-fft_length)) = 0;

% Symmetrie-Umformung um 0Hz
fft_cplx_ltd = fftshift(fft_cplx_ltd);

% Aufspalten
fft_abs = abs(fft_cplx_ltd);
fft_ang = angle(fft_cplx_ltd);

% Reduziere Rauschen
fft_ang(fft_abs < 0.001*max(fft_abs)) = 0;
fft_abs(fft_abs < 0.001*max(fft_abs)) = 0;

% Unwrap Phase
if do_unwrap == 1
	fft_ang = unwrap(fft_ang);
end

% Frequenz-Vektor
freq = -fn:df:fn-df;

% Reduziere Null-Daten
if reduce == 1
	fft_ang(fft_abs==0) = [];
	freq(fft_abs==0) = [];
	fft_abs(fft_abs==0) = [];
end


% % Test IFFT
% fft_cplx_back = fft_abs .* exp(1i*fft_ang);
% signal_back = ifft(ifftshift(fft_cplx_back));
% 
% 
% % Plots
% figure(1)
% subplot(2,1,1)
% plot(freq, fft_abs)
% subplot(2,1,2)
% plot(freq, fft_ang)
% 
% figure(2)
% plot(linspace(0,1,length(signal)), signal, 'b*', linspace(0,1,length(signal)), signal_back, 'r')
